"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrafanaAgentTraceExporter = void 0;
var core_1 = require("@opentelemetry/core");
var otlp_transformer_1 = require("@opentelemetry/otlp-transformer");
var GrafanaAgentTraceExporter = /** @class */ (function () {
    function GrafanaAgentTraceExporter(config) {
        this.config = config;
    }
    GrafanaAgentTraceExporter.prototype.export = function (spans, resultCallback) {
        var traceEvent = exportTraceServiceRequestToTraceEvent((0, otlp_transformer_1.createExportTraceServiceRequest)(spans, true));
        this.config.agent.api.pushTraces(traceEvent);
        resultCallback({ code: core_1.ExportResultCode.SUCCESS });
    };
    GrafanaAgentTraceExporter.prototype.shutdown = function () {
        return Promise.resolve(undefined);
    };
    return GrafanaAgentTraceExporter;
}());
exports.GrafanaAgentTraceExporter = GrafanaAgentTraceExporter;
// @TODO temporary, transforming trace export request to earlier version where "scope" -> "instrumentationLibrary"
function exportTraceServiceRequestToTraceEvent(req) {
    var resourceSpans = req.resourceSpans, rest = __rest(req, ["resourceSpans"]);
    return __assign(__assign({}, rest), { resourceSpans: resourceSpans === null || resourceSpans === void 0 ? void 0 : resourceSpans.map(function (rsp) {
            var scopeSpans = rsp.scopeSpans, rest = __rest(rsp, ["scopeSpans"]);
            return __assign(__assign({}, rest), { instrumentationLibrarySpans: scopeSpans === null || scopeSpans === void 0 ? void 0 : scopeSpans.map(function (scopeSpan) {
                    var scope = scopeSpan.scope, rest = __rest(scopeSpan, ["scope"]);
                    return __assign(__assign({}, rest), { instrumentationLibrary: scope });
                }) });
        }) });
}
//# sourceMappingURL=agent-exporter.js.map